package com.jzdsh.common.database;

import com.jfinal.kit.Kv;
import com.jfinal.plugin.activerecord.generator.BaseModelGenerator;
import com.jfinal.plugin.activerecord.generator.TableMeta;

public class _BaseModelGenerator extends BaseModelGenerator {
	
	public _BaseModelGenerator(String baseModelPackageName, String baseModelOutputDir) {
		super(baseModelPackageName, baseModelOutputDir);
	}

	@Override
	protected void genBaseModelContent(TableMeta tableMeta) {

		Kv data = Kv.by("baseModelPackageName", baseModelPackageName);
		data.set("generateChainSetter", generateChainSetter);
		data.set("tableMeta", tableMeta);

		tableMeta.baseModelContent = engine.getTemplate(template).renderToString(data);

		StringBuilder ret = new StringBuilder("implements IBean {\r\n\r\n");
		genTableName(tableMeta,ret);
		genSelectFrom(ret);

		tableMeta.baseModelContent = tableMeta.baseModelContent.replace("implements IBean {",ret.toString());
	}

	
	protected String tableNameTemplate =	
	"\t/**%n"+
	"\t * 表名%n"+
	"\t */%n"+
	"\tpublic static final String TableName = \"%s\";%n%n";
	
	private void genTableName(TableMeta tableMeta, StringBuilder ret) {
		ret.append(String.format(tableNameTemplate, tableMeta.name));
	}
	
	protected String selectFromTemplate =	
			"\t/**%n"+
			"\t * select fields from tablename 根据查询字段自动构建select 语句%n"+
			"\t */%n"+
			"\tpublic static String SelectFrom(String fields){%n"+
			"\t\treturn String.format(\"select %%s from %%s \",fields,TableName);%n"+
			"\t}%n%n";
	
			private void genSelectFrom(StringBuilder ret) {
				ret.append(String.format(selectFromTemplate));
			}
}
