package com.jzdsh.common;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Calendar;
import java.util.Date;

public class DateUtil {

	/**
	 * 默认的格式化方法 yyyy-MM-dd HH:mm:ss
	 * @param date
	 * @return
	 */
	public static String dateToStr(Date date){
		return dateToStr(date,"yyyy-MM-dd HH:mm:ss");
	}

	public static String dateToStr(Date date,String format){
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(date);
	}

	public static  String dateToStr(LocalDate date,String format){
		DateTimeFormatter df = DateTimeFormatter.ofPattern(format);
		return df.format(date);
	}

	public static Date strToDate(String dateStr,String format){
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		try {
			return sdf.parse(dateStr);
		} catch (ParseException e) {
			return null;
		}
	}
	
	public static Date loacalDateToDate(LocalDate date){
		return Date.from(date.atStartOfDay().atZone(ZoneId.systemDefault()).toInstant());
	} 
	
	public static LocalDate dateToLocalDate(Date date){
		if(null != date){
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(date);

			return LocalDate.of(calendar.get(Calendar.YEAR),calendar.get(Calendar.MONTH)+1,calendar.get(Calendar.DAY_OF_MONTH));
		}else {
			return null;
		}
		//return date.toInstant().atZone(ZoneId.systemDefault()).toLocalDate();
	}

	public static Date loacalDateTimeToDate(LocalDateTime date){
		return Date.from(date.atZone(ZoneId.systemDefault()).toInstant());
	}

	public static LocalDateTime dateToLocalDateTime(Date date){
		if(null != date){
			return LocalDateTime.ofInstant(date.toInstant(),ZoneId.systemDefault());
		}else {
			return null;
		}
	}

}
